package door

import "testing"

func BenchmarkSpinRite(b *testing.B) {
	Unicode = false
	var spin SpinRite = SpinRiteInit(15, 5,
		ColorText("RED ON GREEN"))

	for i := 0; i < b.N; i++ {
		spin.Output()
	}
}
func BenchmarkSpinRiteMsg(b *testing.B) {
	Unicode = false
	var spin SpinRiteMsg = SpinRiteMsgInit(15, 5,
		ColorText("RED ON GREEN"),
		[]string{"RED", "GREEN", "SOFTWARE"})

	for i := 0; i < b.N; i++ {
		spin.Output()
	}
}

func BenchmarkSpinRiteUnicode(b *testing.B) {
	Unicode = true
	var spin SpinRite = SpinRiteInit(15, 5,
		ColorText("RED ON GREEN"))

	for i := 0; i < b.N; i++ {
		spin.Output()
	}
}
func BenchmarkSpinRiteMsgUnicode(b *testing.B) {
	Unicode = true
	var spin SpinRiteMsg = SpinRiteMsgInit(15, 5,
		ColorText("RED ON GREEN"),
		[]string{"RED", "GREEN", "SOFTWARE"})

	for i := 0; i < b.N; i++ {
		spin.Output()
	}
}
